#ifndef __RECTANGLE_HH_
#define __RECTANGLE_HH_


#include <iostream>


using namespace std;



/**
 * @brief This class implements a 2D rectangle.
 * 
 * It stores the cartesian coordinates xMin, xMax, yMin and yMax of the
 * rectangle represented.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007 
 *****************************************************************************/
class Rectangle {

public:

  // Destructor
  virtual ~Rectangle();


  // Get functions
  virtual double getXMin() const = 0;
  virtual double getXMax() const = 0;
  virtual double getYMin() const = 0;
  virtual double getYMax() const = 0;


  // Friend write function
  friend ostream & operator<<(ostream & ostr, Rectangle const & rectangle);
};



/**
 * @brief The virtual destructor.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007
 *****************************************************************************/
inline Rectangle::~Rectangle() {}



#endif // __RECTANGLE_HH_
