#include <cstdlib>
#include <iostream>
#include <iomanip>

#include "mapmrtcrdp.hh"


using namespace std;




int main(int argc, char * argv[])
{
  // Testing inline arguments
  if (argc < 2)
    {
      cerr << "Usage: " << argv[0] << " <nearTolerance>" << endl;
      exit(1);
    }


  // Setting needed flags
  cerr.setf(ios::scientific, ios::floatfield);
  cerr.setf(ios::uppercase);
  cerr.precision(COORD_PRECISION);


  // Reading near tolerance
  double nearTolerance;
  nearTolerance = atof(argv[1]);

  cerr << setw(14) << nearTolerance << endl;

  // Reading map
  MapMRTCRDP mapMRTCRDP;
  cin >> mapMRTCRDP;


  // Applying Topologically Consistent RDP simplication
  mapMRTCRDP.simplifyMRTCRDP(nearTolerance);

  cerr << "FIM" << endl;


  // Writing simplified map
  cout << mapMRTCRDP;


  return 0;
}
