#include "rectangle.hh"

#include <iomanip>




/**
 * @brief It writes @a rectangle in the stream @a ostr.
 *
 * It writes the coordinates xMin, xMax, yMin and yMax.  Each coordinate
 * will occupy a field of width 14.
 *
 * @param ostr Output stream.
 * @param rectangle The rectangle to write.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007
 *****************************************************************************/
ostream & operator<<(ostream & ostr, Rectangle const & rectangle)
{
  return ostr << setw(14) << rectangle.getXMin()
	      << setw(14) << rectangle.getXMax()
	      << setw(14) << rectangle.getYMin()
	      << setw(14) << rectangle.getYMax();
}
