#include "vertex.hh"

#include <iomanip>




/**
 * @brief It prints this qvertex in the stream @a ostr.
 *
 * It prints the coordinates x and y and the erased flag separeted by commas
 * in a single line.
 *
 * @param ostr Output stream.
 * @param width Width of field the coordinates will occupy.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007
 *****************************************************************************/
void Vertex::print(ostream & ostr, int width) const
{
  ostr << setw(width) << x << ", "
       << setw(width) << y << ", "
       << boolalpha   << erased << endl;
}
