#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <sys/time.h>

#include "maptcrdp.hh"


using namespace std;




int main(int argc, char * argv[])
{
  /* Testing inline arguments */
  if (argc < 2)
    {
      cerr << "Usage: " << argv[0] << " <tolerance>" << endl;
      exit(1);
    }


  /* Reading tolerance */
  double tolerance;
  tolerance = atof(argv[1]);


  /* Reading map */
  MapTCRDP mapTCRDP;
  cin >> mapTCRDP;

  cerr.setf(ios::scientific, ios::floatfield);
  cerr.setf(ios::uppercase);
  cerr.precision(COORD_PRECISION);
  
  timeval bgnTime;
  timeval endTime;
  double diffTime;

  gettimeofday(&bgnTime, NULL);


  /* Applying Topologically Consistent Ramer-Douglas-Peucker simplication */
  mapTCRDP.simplifyTCRDP(tolerance);


  gettimeofday(&endTime, NULL);
  diffTime = ((endTime.tv_sec -bgnTime.tv_sec)+
	      (endTime.tv_usec-bgnTime.tv_usec)/1E6);
//   cerr << "Time:      " << setw(14) << diffTime << endl;
  cerr << setw(14) << diffTime << endl;


  /* Writing simplified map */
  cout << mapTCRDP;


  return 0;
}
