#ifndef __POLYLINE_HH_
#define __POLYLINE_HH_


#include "point.hh"

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 * 'Polyline' is a vector of Points.
 *****************************************************************************/
class Polyline
  : public vector<Point> {

public:

  /* Polyline's number of vertices function */
  unsigned numberOfVertices() const;

  /* Friendship relation of insertion and extraction operators */
  friend ostream & operator<<(ostream & ostr, Polyline const & polyline);
  friend istream & operator>>(istream & istr, Polyline       & polyline);

  /* Printing function */
  void print(ostream & ostr) const;


private:

  /* Internal print function */
  void print(ostream & ostr, unsigned frstIdx, unsigned lastIdx) const;
};



inline unsigned Polyline::numberOfVertices() const { return size(); }

inline void Polyline::print(ostream & ostr) const { print(ostr, 0, size()-1); }



#endif // __POLYLINE_HH_
