#include "vertex.hh"

#include <iomanip>




/**
 * @brief Prints vertex in @a ostr.
 *
 * First, prints the coordinates x and y, and the distance.
 *
 * @param ostr Output stream in where to print.
 * @param width Width of field coordinates and distance occupy.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007
 *****************************************************************************/
void Vertex::print(ostream & ostr, int width) const
{
  ostr << setw(width) << x << ", "
       << setw(width) << y << ", "
       << setw(width) << effectiveArea << endl;
}



/**
 * @brief It writes @a vertex in the stream @a ostr.
 *
 * First, it writes the vertex coordinates, then its distance.
 *
 * @param ostr Output stream in where to write.
 * @param vertex The vertex to write.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007
 *****************************************************************************/
ostream & operator<<(ostream & ostr, Vertex const & vertex)
{
  ostr << setw(COORD_WIDTH) << vertex.x
       << setw(COORD_WIDTH) << vertex.y
       << setw(COORD_WIDTH) << vertex.effectiveArea;


  return ostr;
}
