#include "point.hh"

#include <iomanip>




/**
 * @brief Prints point in @a ostr.
 *
 * First, prints the coordinates x and y.
 *
 * @param ostr Output stream in where to printe.
 * @param width Width of the field coordinates occupy.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007
 *****************************************************************************/
void Point::print(ostream & ostr, int width) const
{
  ostr << setw(width) << x << ", "
       << setw(width) << y << endl;
}



/**
 * @brief Writes @a point's coordinates in @a ostr.
 *
 * @param ostr Output stream in where to write.
 * @param point The point to write.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007
 *****************************************************************************/
ostream & operator<<(ostream & ostr, Point const & point)
{
  ostr << setw(COORD_WIDTH) << point.x
       << setw(COORD_WIDTH) << point.y;


  return ostr;
}



/**
 * @brief Reads @a point's coordinates from @a istr.
 *
 * @param istr Input stream from where to read.
 * @param point The point to store readed coordinates.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007
 *****************************************************************************/
istream & operator>>(istream & istr, Point & point)
{
  istr >> point.x >> point.y;


  return istr;
}
