#include "vertex.hh"

#include <iomanip>




/**
 * @brief Prints vertex in @a ostr.
 *
 * First, prints the coordinates x and y, and the erased flag.
 *
 * @param ostr Output stream in where to printe.
 * @param width Width of field coordinates occupy.
 *
 * @author Adler da Silva
 * @date   Last update: 30/07/2007
 *****************************************************************************/
void Vertex::print(ostream & ostr, int width) const
{
  ostr << setw(width) << x << ", "
       << setw(width) << y << ", "
       << boolalpha   << erased << endl;
}
