#ifndef __CNTSECTION_HH_
#define __CNTSECTION_HH_


#include <e00/section.hh>
#include <e00/e00point.hh>

#include <iostream>
#include <vector>
#include <list>



/* CNT (centroid) structured type - labels + centroid */
struct cntField_t
{
  int nLabels;
  E00Point centroid;
  vector<int> labels;

  cntField_t(int nLabels) : nLabels(nLabels) {}

  friend istream & operator>>(istream & istr, cntField_t       & cntField);
  friend ostream & operator<<(ostream & ostr, cntField_t const & cntField);
};



/******************************************************************************
 *
 *****************************************************************************/
class CNTSection
  : public list<cntField_t>,
    public Section {

public:

  friend istream & operator>>(istream & istr, CNTSection       & cntSection);
  friend ostream & operator<<(ostream & ostr, CNTSection const & cntSection);
};



#endif // __CNTSECTION_HH_
