#ifndef __TICFILE_HH_
#define __TICFILE_HH_


#include <e00/ifofile.hh>

#include <iostream>
#include <vector>



/* TIC (Tic Coordinates) record structured type */
struct ticRecord_t
{
  int IDTic;
  double xTic;
  double yTic;

  friend istream & operator>>(istream & istr, ticRecord_t       & ticRecord);
  friend ostream & operator<<(ostream & ostr, ticRecord_t const & ticRecord);
};



/******************************************************************************
 *
 *****************************************************************************/
class TICFile
  : public IFOFile {
    
public:

  /* Get records function */
  vector<ticRecord_t>       & getRecords();
  vector<ticRecord_t> const & getRecords() const;

  /* Insertion and extraction overloaded operators */
  friend istream & operator>>(istream & istr, TICFile       & ticFile);
  friend ostream & operator<<(ostream & ostr, TICFile const & ticFile);


private:

  vector<ticRecord_t> records;
};


inline vector<ticRecord_t>       & TICFile::getRecords() { return records; }
inline vector<ticRecord_t> const & TICFile::getRecords() const
{
  return records;
}



#endif // __TICFILE_HH_
