#ifndef __TOLSECTION_HH_
#define __TOLSECTION_HH_


#include <e00/section.hh>

#include <iostream>
#include <vector>
#include <list>


/* TOL (tolerance) field structured type - array of 10 tolerances */
struct tolField_t
{
  int type;
  int status;

  double value;

  tolField_t(int type) : type(type) {}

  friend istream & operator>>(istream & istr, tolField_t       & tolField);
  friend ostream & operator<<(ostream & ostr, tolField_t const & tolField);
};



/******************************************************************************
 *
 *****************************************************************************/
class TOLSection
  : public list<tolField_t>,
    public Section {

public:

  friend istream & operator>>(istream & istr, TOLSection       & tolSection);
  friend ostream & operator<<(ostream & ostr, TOLSection const & tolSection);
};



#endif // __TOLSECTION_HH_
