#ifndef __MLFLABEL_HH_
#define __MLFLABEL_HH_


#include <mlf/mlfpoint.hh>

#include <string>



/******************************************************************************
 *
 *****************************************************************************/
class MLFLabel {

public:

  /* Get functions */
  MLFPoint const & getPosition() const;
  string   const & getName() const;

  /* Set functions */
  void setPosition(MLFPoint const & position);
  void setName(string const & name);

  /* Overload of insertion and extraction operator */
  friend istream & operator>>(istream & istr, MLFLabel       & label);
  friend ostream & operator<<(ostream & ostr, MLFLabel const & label);


private:

  MLFPoint position;
  string name;
};


inline MLFPoint  const & MLFLabel::getPosition() const { return position; }
inline string    const & MLFLabel::getName() const     { return name; }

inline void MLFLabel::setPosition(MLFPoint const & p) { position = p; }
inline void MLFLabel::setName(string const & n)       { name     = n; }



#endif // __MLFLABEL_HH_
