#ifndef __MLFPOLYGON_HH_
#define __MLFPOLYGON_HH_


#include <iostream>
#include <vector>


using namespace std;



struct MLFPolIndex_t {

  MLFPolIndex_t(int polylineIdx = 0, bool reversed = false)
    : polylineIdx(polylineIdx), reversed(reversed) {}

  int  polylineIdx;
  bool reversed;
};


/******************************************************************************
 *
 *****************************************************************************/
class MLFPolygon
  : public vector<MLFPolIndex_t> {

public:

  /* Get number of polylines function */
  unsigned numberOfPolylines() const;

  /* Get and set functions */
  int  getType() const;
  void setType(int type);

  /* Redifinion of insertion and extraction operators */
  friend istream & operator>>(istream & istr, MLFPolygon       & polygon);
  friend ostream & operator<<(ostream & ostr, MLFPolygon const & polygon);


private:

  int type;
};


inline unsigned MLFPolygon::numberOfPolylines() const { return size(); }

inline int  MLFPolygon::getType() const { return type; }
inline void MLFPolygon::setType(int type) { this->type = type; }



#endif // __MLFPOLYGON_HH_
