#ifndef __MLFPOLYLINE_HH_
#define __MLFPOLYLINE_HH_


#include <mlf/mlfpoint.hh>
#include <e00/e00polyline.hh>

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 *
 *****************************************************************************/
class MLFPolyline
  : public vector<MLFPoint> {

public:

  /* Constructor */
  MLFPolyline(unsigned nVertices = 0);

  /* Get number of vertices function */
  unsigned numberOfVertices() const;

  /* Equal operator overloaded */
  MLFPolyline const & operator=(E00Polyline const & polyline);

  /* Redifinion of insertion and extraction operators */
  friend istream & operator>>(istream & istr, MLFPolyline       & polyline);
  friend ostream & operator<<(ostream & ostr, MLFPolyline const & polyline);
};


inline MLFPolyline::MLFPolyline(unsigned nVertices)
  : vector<MLFPoint>(nVertices) {}

inline unsigned MLFPolyline::numberOfVertices() const { return size(); }

inline MLFPolyline const & MLFPolyline::operator=(E00Polyline const & polyline)
{
  resize(polyline.numberOfVertices());

  for (unsigned vertexIdx = 0; vertexIdx < numberOfVertices(); ++vertexIdx)
    (*this)[vertexIdx] = polyline[vertexIdx];

  return *this;
}



#endif // __MLFPOLYLINE_HH_
