#ifndef __MMFLABEL_HH_
#define __MMFLABEL_HH_


#include <mmf/mmfpoint.hh>
#include <mlf/mlflabel.hh>

#include <string>



/******************************************************************************
 *
 *****************************************************************************/
class MMFLabel {

public:

  /* Constructors */
  MMFLabel();
  MMFLabel(MLFLabel const & label);

  /* Get functions */
  MMFPoint const & getPosition() const;
  string   const & getName() const;

  /* Set functions */
  void setPosition(MMFPoint const & position);
  void setName(string const & name);

  /* Overload of insertion and extraction operator */
  friend istream & operator>>(istream & istr, MMFLabel       & label);
  friend ostream & operator<<(ostream & ostr, MMFLabel const & label);


private:

  MMFPoint position;
  string name;
};


inline MMFLabel::MMFLabel() {}
inline MMFLabel::MMFLabel(MLFLabel const & label)
  : position(label.getPosition()), name(label.getName()) {}

inline MMFPoint  const & MMFLabel::getPosition() const { return position; }
inline string    const & MMFLabel::getName() const     { return name; }

inline void MMFLabel::setPosition(MMFPoint const & p) { position = p; }
inline void MMFLabel::setName(string const & n)       { name     = n; }



#endif // __MMFLABEL_HH_
