#ifndef __MMFLINK_HH_
#define __MMFLINK_HH_


#include <iostream>



using namespace std;



/******************************************************************************
 * 'MMFLink' is the link class. It carries the a link between two resolutions.
 *****************************************************************************/
class MMFLink {

public:

  /* Constructor */
  MMFLink(unsigned vertexIdx = 0, unsigned resolutionID = 0);

  /* Get functions */
  unsigned getVertexIdx() const;
  unsigned getResolutionIdx() const;

  /* Set functions */
  void setVertexIdx    (unsigned vertexIdx);
  void setResolutionIdx(unsigned resolutionIdx);

  /* Friend operators for input and output handling */
  friend istream & operator>>(istream & istr, MMFLink       & link);
  friend ostream & operator<<(ostream & ostr, MMFLink const & link);


private:

  /* Vertex index where the link come from */
  unsigned vertexIdx;

  /* Next resolution index */
  unsigned resolutionIdx;
};



inline MMFLink::MMFLink(unsigned vertexIdx, unsigned resolutionIdx)
  : vertexIdx(vertexIdx), resolutionIdx(resolutionIdx) {}

inline unsigned MMFLink::getVertexIdx() const     { return vertexIdx; }
inline unsigned MMFLink::getResolutionIdx() const { return resolutionIdx; }

inline void MMFLink::setVertexIdx    (unsigned idx) { vertexIdx = idx; }
inline void MMFLink::setResolutionIdx(unsigned idx) { resolutionIdx = idx; }



#endif //__MMFLINK_HH_
