#ifndef __MMFPOLYLINE_HH_
#define __MMFPOLYLINE_HH_


#include <mmf/mmfresolution.hh>
#include <mlf/mlfpolyline.hh>
#include <e00/e00polyline.hh>

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 *
 *****************************************************************************/
class MMFPolyline
  : public vector<MMFResolution> {

public:

  /* Constructor */
  MMFPolyline(unsigned nResolutions = 1);
  MMFPolyline(MLFPolyline const & polyline);

  /* Getting functions */
  unsigned numberOfResolutions() const;
  vector<MMFPoint const *> const & getVertices(unsigned resolutionIdx) const;

  /* Setting functions */
  void setNumberOfResolutions(unsigned nResolutions);

  /* Equal operator overloaded */
  MMFPolyline const & operator=(MLFPolyline const & polyline);
  MMFPolyline const & operator=(E00Polyline const & polyline);

  /* Redifinion of insertion and extraction operators */
  friend istream & operator>>(istream & istr, MMFPolyline       & polyline);
  friend ostream & operator<<(ostream & ostr, MMFPolyline const & polyline);
};


inline MMFPolyline::MMFPolyline(unsigned nResolutions)
  : vector<MMFResolution>(nResolutions) {}

inline unsigned MMFPolyline::numberOfResolutions() const { return size(); }
inline void     MMFPolyline::setNumberOfResolutions(unsigned nResolutions)
{
  resize(nResolutions);
}



#endif // __MMFPOLYLINE_HH_
