#ifndef __MMFRARLAYER_HH_
#define __MMFRARLAYER_HH_


#include <mmf/mmflayer.hh>
#include <mmf/mmfpolyline.hh>
#include <mlf/mlfrarlayer.hh>
#include <e00/expfile.hh>

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 *
 *****************************************************************************/
class MMFRARLayer
  : public MMFLayer {

public:

  /* Constructors */
  MMFRARLayer(string const & name);
  MMFRARLayer(string const & name, EXPFile const & expFile);
  MMFRARLayer(MLFRARLayer const & rarLayer);

  unsigned numberOfPolylines() const;

  MMFPolyline const & getPolyline(unsigned polylineIdx) const;

  MMFPolyline & getPolyline(unsigned polylineIdx);

  friend istream & operator>>(istream & istr, MMFRARLayer       & rarLayer);
  friend ostream & operator<<(ostream & ostr, MMFRARLayer const & rarLayer);


private:

  vector<MMFPolyline> polylines;

  void findBoundingBox();
};


inline MMFRARLayer::MMFRARLayer(string const & name) : MMFLayer(name) {}
inline MMFRARLayer::MMFRARLayer(MLFRARLayer const & rarLayer)
  : MMFLayer(rarLayer)
{
  polylines.insert(polylines.end(),
		   rarLayer.getPolylines().begin(),
		   rarLayer.getPolylines().end());
}

inline unsigned MMFRARLayer::numberOfPolylines() const
{
  return polylines.size();
}

inline MMFPolyline const & MMFRARLayer::getPolyline(unsigned polylineIdx) const
{
  return polylines[polylineIdx];
}


inline MMFPolyline & MMFRARLayer::getPolyline(unsigned polylineIdx)
{
  return polylines[polylineIdx];
}



#endif // __MMFRARLAYER_HH_
