#ifndef __MTFLABEL_HH_
#define __MTFLABEL_HH_


#include <mtf/mtfpoint.hh>
#include <mlf/mlflabel.hh>

#include <string>



/******************************************************************************
 *
 *****************************************************************************/
class MTFLabel {

public:

  /* Constructor */
  MTFLabel();
  MTFLabel(MLFLabel const & label);

  /* Get functions */
  MTFPoint const & getPosition() const;
  string   const & getName() const;

  /* Set functions */
  void setPosition(MTFPoint const & position);
  void setName(string const & name);

  /* Overload of insertion and extraction operator */
  friend istream & operator>>(istream & istr, MTFLabel       & label);
  friend ostream & operator<<(ostream & ostr, MTFLabel const & label);


private:

  MTFPoint position;
  string name;
};


inline MTFLabel::MTFLabel() {}
inline MTFLabel::MTFLabel(MLFLabel const & label)
  : position(label.getPosition()), name(label.getName()) {}

inline MTFPoint  const & MTFLabel::getPosition() const { return position; }
inline string    const & MTFLabel::getName() const     { return name; }

inline void MTFLabel::setPosition(MTFPoint const & p) { position = p; }
inline void MTFLabel::setName(string const & n)       { name     = n; }



#endif // __MTFLABEL_HH_
