#ifndef __MTFPOLYLINE_HH_
#define __MTFPOLYLINE_HH_


#include <mtf/mtfpoint.hh>
#include <mlf/mlfpolyline.hh>

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 *
 *****************************************************************************/
class MTFPolyline
  : public vector<MTFPoint> {

public:

  /* Constructor */
  MTFPolyline(unsigned nVertices = 0);
  MTFPolyline(MLFPolyline const & polyline);

  /* Get number of vertices function */
  unsigned numberOfVertices() const;

  /* Equal operator overloaded */
  MTFPolyline const & operator=(MLFPolyline const & polyline);

  /* Redifinion of insertion and extraction operators */
  friend istream & operator>>(istream & istr, MTFPolyline       & polyline);
  friend ostream & operator<<(ostream & ostr, MTFPolyline const & polyline);
};


inline MTFPolyline::MTFPolyline(unsigned nVertices)
  : vector<MTFPoint>(nVertices) {}
inline MTFPolyline::MTFPolyline(MLFPolyline const & polyline)
  : vector<MTFPoint>(polyline.begin(), polyline.end()) {}

inline unsigned MTFPolyline::numberOfVertices() const { return size(); }

inline MTFPolyline const & MTFPolyline::operator=(MLFPolyline const & polyline)
{
  resize(polyline.numberOfVertices());

  for (unsigned vertexIdx = 0; vertexIdx < numberOfVertices(); ++vertexIdx)
    (*this)[vertexIdx] = polyline[vertexIdx];

  return *this;
}



#endif // __MTFPOLYLINE_HH_
