#ifndef __MTFRARLAYER_HH_
#define __MTFRARLAYER_HH_


#include <mtf/mtflayer.hh>
#include <mtf/mtfpolyline.hh>
#include <mlf/mlfrarlayer.hh>

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 *
 *****************************************************************************/
class MTFRARLayer
  : public MTFLayer {

public:

  /* Constructors */
  MTFRARLayer(string const & name);
  MTFRARLayer(MLFRARLayer const & rarLayer);

  unsigned numberOfPolylines() const;

  MTFPolyline const & getPolyline(unsigned polylineIdx) const;
  vector<MTFPolyline> const & getPolylines() const;

  MTFPolyline & getPolyline(unsigned polylineIdx);
  vector<MTFPolyline> & getPolylines();

  friend istream & operator>>(istream & istr, MTFRARLayer       & rarLayer);
  friend ostream & operator<<(ostream & ostr, MTFRARLayer const & rarLayer);


private:

  vector<MTFPolyline> polylines;

  void findBoundingBox();
};


inline MTFRARLayer::MTFRARLayer(string const & name) : MTFLayer(name) {}
inline MTFRARLayer::MTFRARLayer(MLFRARLayer const & rarLayer)
  : MTFLayer(rarLayer),
    polylines(rarLayer.getPolylines().begin(), rarLayer.getPolylines().end()){}

inline unsigned MTFRARLayer::numberOfPolylines() const
{
  return polylines.size();
}

inline MTFPolyline const & MTFRARLayer::getPolyline(unsigned polylineIdx) const
{
  return polylines[polylineIdx];
}

inline vector<MTFPolyline> const & MTFRARLayer::getPolylines() const
{
  return polylines;
}


inline MTFPolyline & MTFRARLayer::getPolyline(unsigned polylineIdx)
{
  return polylines[polylineIdx];
}

inline vector<MTFPolyline> & MTFRARLayer::getPolylines() { return polylines; }



#endif // __MTFRARLAYER_HH_
