#ifndef __MVFLABEL_HH_
#define __MVFLABEL_HH_


#include <mvf/mvfpoint.hh>
#include <mlf/mlflabel.hh>

#include <string>



/******************************************************************************
 *
 *****************************************************************************/
class MVFLabel {

public:

  /* Constructor */
  MVFLabel();
  MVFLabel(MLFLabel const & label);

  /* Get functions */
  MVFPoint const & getPosition() const;
  string   const & getName() const;

  /* Set functions */
  void setPosition(MVFPoint const & position);
  void setName(string const & name);

  /* Overload of insertion and extraction operator */
  friend istream & operator>>(istream & istr, MVFLabel       & label);
  friend ostream & operator<<(ostream & ostr, MVFLabel const & label);


private:

  MVFPoint position;
  string name;
};


inline MVFLabel::MVFLabel() {}
inline MVFLabel::MVFLabel(MLFLabel const & label)
  : position(label.getPosition()), name(label.getName()) {}

inline MVFPoint  const & MVFLabel::getPosition() const { return position; }
inline string    const & MVFLabel::getName() const     { return name; }

inline void MVFLabel::setPosition(MVFPoint const & p) { position = p; }
inline void MVFLabel::setName(string const & n)       { name     = n; }



#endif // __MVFLABEL_HH_
