#ifndef __MVFPOLYLINE_HH_
#define __MVFPOLYLINE_HH_


#include <mvf/mvfpoint.hh>
#include <mlf/mlfpolyline.hh>

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 *
 *****************************************************************************/
class MVFPolyline
  : public vector<MVFPoint> {

public:

  /* Constructor */
  MVFPolyline(unsigned nVertices = 0);
  MVFPolyline(MLFPolyline const & polyline);

  /* Get number of vertices function */
  unsigned numberOfVertices() const;

  /* Equal operator overloaded */
  MVFPolyline const & operator=(MLFPolyline const & polyline);

  /* Redifinion of insertion and extraction operators */
  friend istream & operator>>(istream & istr, MVFPolyline       & polyline);
  friend ostream & operator<<(ostream & ostr, MVFPolyline const & polyline);
};


inline MVFPolyline::MVFPolyline(unsigned nVertices)
  : vector<MVFPoint>(nVertices) {}
inline MVFPolyline::MVFPolyline(MLFPolyline const & polyline)
  : vector<MVFPoint>(polyline.begin(), polyline.end()) {}

inline unsigned MVFPolyline::numberOfVertices() const { return size(); }

inline MVFPolyline const & MVFPolyline::operator=(MLFPolyline const & polyline)
{
  resize(polyline.numberOfVertices());

  for (unsigned vertexIdx = 0; vertexIdx < numberOfVertices(); ++vertexIdx)
    (*this)[vertexIdx] = polyline[vertexIdx];

  return *this;
}



#endif // __MVFPOLYLINE_HH_
