#ifndef __MVFRARLAYER_HH_
#define __MVFRARLAYER_HH_


#include <mvf/mvflayer.hh>
#include <mvf/mvfpolyline.hh>
#include <mlf/mlfrarlayer.hh>

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 *
 *****************************************************************************/
class MVFRARLayer
  : public MVFLayer {

public:

  /* Constructors */
  MVFRARLayer(string const & name);
  MVFRARLayer(MLFRARLayer const & rarLayer);

  unsigned numberOfPolylines() const;

  MVFPolyline const & getPolyline(unsigned polylineIdx) const;
  vector<MVFPolyline> const & getPolylines() const;

  MVFPolyline & getPolyline(unsigned polylineIdx);
  vector<MVFPolyline> & getPolylines();

  friend istream & operator>>(istream & istr, MVFRARLayer       & rarLayer);
  friend ostream & operator<<(ostream & ostr, MVFRARLayer const & rarLayer);


private:

  vector<MVFPolyline> polylines;

  void findBoundingBox();
};


inline MVFRARLayer::MVFRARLayer(string const & name) : MVFLayer(name) {}
inline MVFRARLayer::MVFRARLayer(MLFRARLayer const & rarLayer)
  : MVFLayer(rarLayer),
    polylines(rarLayer.getPolylines().begin(), rarLayer.getPolylines().end()){}

inline unsigned MVFRARLayer::numberOfPolylines() const
{
  return polylines.size();
}

inline MVFPolyline const & MVFRARLayer::getPolyline(unsigned polylineIdx) const
{
  return polylines[polylineIdx];
}

inline vector<MVFPolyline> const & MVFRARLayer::getPolylines() const
{
  return polylines;
}


inline MVFPolyline & MVFRARLayer::getPolyline(unsigned polylineIdx)
{
  return polylines[polylineIdx];
}

inline vector<MVFPolyline> & MVFRARLayer::getPolylines() { return polylines; }



#endif // __MVFRARLAYER_HH_
