#ifndef __LABEL_HH_
#define __LABEL_HH_


#include <base/point.hh>

#include <string>



/******************************************************************************
 *
 *****************************************************************************/
class Label {

public:

  /* Get functions */
  Point  const & getPosition() const;
  string const & getName() const;

  /* Set functions */
  void setPosition(Point const & position);
  void setName(string const & name);

  /* Overload of insertion and extraction operator */
  friend istream & operator>>(istream & istr, Label       & label);
  friend ostream & operator<<(ostream & ostr, Label const & label);


private:

  Point position;
  string name;
};


inline Point  const & Label::getPosition() const { return position; }
inline string const & Label::getName() const     { return name; }

inline void Label::setPosition(Point const & p) { this->position = p; }
inline void Label::setName(string const & name) { this->name     = name; }



#endif // __LABEL_HH_
