#include <base/polyline.hh>

#include <iomanip>





/******************************************************************************
 * istr >> polyline
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, Polyline & polyline)
{
  for (unsigned vertexIdx = 0; vertexIdx < polyline.size(); ++vertexIdx)
    istr >> polyline[vertexIdx];

  return istr;
}



/******************************************************************************
 * ostr << polyline
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, Polyline const & polyline)
{
  for (unsigned vertexIdx = 0; vertexIdx < polyline.size(); ++vertexIdx)
    {
      if (ostr.precision() == 14 || vertexIdx%2 == 0)
	ostr.put(ostr.widen('\r')).put(ostr.widen('\n')).flush();

      ostr << polyline[vertexIdx];
    }

  return ostr.put(ostr.widen('\r')).put(ostr.widen('\n')).flush();
}



/******************************************************************************
 * polyline.read(istr)
 ******************************************************************************
 *
 *****************************************************************************/
void Polyline::read(istream & istr)
{
  unsigned nPoints;
  istr >> nPoints;

  resize(nPoints);
  for (unsigned vertexIdx = 0; vertexIdx < size(); ++vertexIdx)
    istr >> (*this)[vertexIdx];
}



/******************************************************************************
 * polyline.write(ostr)
 ******************************************************************************
 *
 *****************************************************************************/
void Polyline::write(ostream & ostr) const
{
  ostr << size();

  for (unsigned vertexIdx = 0; vertexIdx < size(); ++vertexIdx)
    {
      if (ostr.precision() == 14 || vertexIdx%2 == 0)
	ostr.put(ostr.widen('\n')).flush();

      ostr << (*this)[vertexIdx];
    }

  ostr.put(ostr.widen('\n')).flush();
}
