#ifndef __AATFILE_HH_
#define __AATFILE_HH_


#include <e00/ifofile.hh>

#include <iostream>
#include <vector>
#include <string>



/* AAT (Arc Attribute Table) record structured type */
struct aatRecord_t
{
  int frNode;
  int toNode;

  int leftPolygon;
  int rghtPolygon;

  double length;

  int coverageNumber;
  int coverageID;

  string type_stat;
  int type;
  int stat;

  friend istream & operator>>(istream & istr, aatRecord_t       & aatRecord);
  friend ostream & operator<<(ostream & ostr, aatRecord_t const & aatRecord);
};



/******************************************************************************
 *
 *****************************************************************************/
class AATFile
  : public IFOFile {
    
public:

  /* Get records function */
  vector<aatRecord_t>       & getRecords();
  vector<aatRecord_t> const & getRecords() const;

  /* Insertion and extraction overloaded operators */
  friend istream & operator>>(istream & istr, AATFile       & aatFile);
  friend ostream & operator<<(ostream & ostr, AATFile const & aatFile);


private:

  vector<aatRecord_t> records;
};


inline vector<aatRecord_t>       & AATFile::getRecords() { return records; }
inline vector<aatRecord_t> const & AATFile::getRecords() const
{
  return records;
}



#endif // __AATFILE_HH_
