#include <e00/bndfile.hh>
#include <e00/endl.hh>

#include <iomanip>



/******************************************************************************
 * istr >> bndRecord
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, bndRecord_t & bndRecord)
{
  istr >> bndRecord.xMin >> bndRecord.yMin
       >> bndRecord.xMax >> bndRecord.yMax;

  /* Ignoring last line end */
  return istr.ignore(2, '\n');
}



/******************************************************************************
 * ostr << bndRecord
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, bndRecord_t const & bndRecord)
{
  return ostr << setw((ostr.precision() == 7) ? 14 : 24) << bndRecord.xMin
	      << setw((ostr.precision() == 7) ? 14 : 24) << bndRecord.yMin
	      << setw((ostr.precision() == 7) ? 14 : 24) << bndRecord.xMax
	      << setw((ostr.precision() == 7) ? 14 : 24) << bndRecord.yMax
	      << endl;
}



/******************************************************************************
 * istr >> bndFile
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, BNDFile & bndFile)
{
  istr >> static_cast<IFOFile &>(bndFile);

  bndFile.records.resize(bndFile.ifoHeader.nRecords);
  for (unsigned recordIdx = 0; recordIdx < bndFile.records.size(); ++recordIdx)
    istr >> bndFile.records[recordIdx];

  return istr;
}



/******************************************************************************
 * ostr << bndFile
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, BNDFile const & bndFile)
{
  ostr << static_cast<IFOFile const &>(bndFile);

  for (unsigned recordIdx = 0; recordIdx < bndFile.records.size(); ++recordIdx)
    ostr << bndFile.records[recordIdx];

  return ostr;
}
