#ifndef __BNDFILE_HH_
#define __BNDFILE_HH_


#include <e00/ifofile.hh>

#include <iostream>
#include <vector>



/* BND (Coverage Min/Max Coordinates - Bounding Box) record structured type */
struct bndRecord_t
{
  double xMin, yMin;
  double xMax, yMax;

  friend istream & operator>>(istream & istr, bndRecord_t       & bndRecord);
  friend ostream & operator<<(ostream & ostr, bndRecord_t const & bndRecord);
};



/******************************************************************************
 *
 *****************************************************************************/
class BNDFile
  : public IFOFile {
    
public:

  /* Get records function */
  vector<bndRecord_t>       & getRecords();
  vector<bndRecord_t> const & getRecords() const;

  /* Insertion and extraction overloaded operators */
  friend istream & operator>>(istream & istr, BNDFile       & bndFile);
  friend ostream & operator<<(ostream & ostr, BNDFile const & bndFile);


private:

  vector<bndRecord_t> records;
};


inline vector<bndRecord_t>       & BNDFile::getRecords() { return records; }
inline vector<bndRecord_t> const & BNDFile::getRecords() const
{
  return records;
}



#endif // __BNDFILE_HH_
