#ifndef __E00POINT_HH_
#define __E00POINT_HH_


#include <iostream>



using namespace std;



/******************************************************************************
 * 'E00Point' is the point class. It carries the cartesian coordinates of a
 * point in 2D space. It also presents geometric transformations and util
 * functions usually applied to points.
 *****************************************************************************/
class E00Point {

public:

  /* Constructors */
  E00Point(E00Point const & point);
  E00Point(double x = 0.0, double y = 0.0);

  /* Get functions */
  double getX() const;
  double getY() const;

  /* Set functions */
  void setX(double x);
  void setY(double y);

  /* Friend operators for input and output handling */
  friend istream & operator>>(istream & istr, E00Point       & point);
  friend ostream & operator<<(ostream & ostr, E00Point const & point);


private:

  /* Cartesian coordinates */
  double x, y;
};



inline E00Point::E00Point(E00Point const & point) : x(point.x), y(point.y) {}
inline E00Point::E00Point(double x, double y) : x(x), y(y) {}

inline double E00Point::getX() const { return x; }
inline double E00Point::getY() const { return y; }

inline void E00Point::setX(double x) { this->x = x; }
inline void E00Point::setY(double y) { this->y = y; }



#endif //__E00POINT_HH_
