#include <e00/expfile.hh>
#include <e00/endl.hh>

#include <iomanip>



/******************************************************************************
 * istr >> expFile
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, EXPFile & expFile)
{
  /* Auxiliary buffers */
  char buffer[4];
  string sectionName;

  /* Reading section name */
  istr.getline(buffer, 4).clear();
  sectionName = buffer;

  if (sectionName == "EXP")
    {
      expFile.expSection = new EXPSection;
      expFile.expSection->setName(sectionName);
      istr >> *expFile.expSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "ARC")
    {
      expFile.arcSection = new ARCSection;
      expFile.arcSection->setName(sectionName);
      istr >> *expFile.arcSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "CNT")
    {
      expFile.cntSection = new CNTSection;
      expFile.cntSection->setName(sectionName);
      istr >> *expFile.cntSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "LAB")
    {
      expFile.labSection = new LABSection;
      expFile.labSection->setName(sectionName);
      istr >> *expFile.labSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "PAL")
    {
      expFile.palSection = new PALSection;
      expFile.palSection->setName(sectionName);
      istr >> *expFile.palSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "TOL")
    {
      expFile.tolSection = new TOLSection;
      expFile.tolSection->setName(sectionName);
      istr >> *expFile.tolSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "TX7")
    {
      expFile.tx7Section = new TX7Section;
      expFile.tx7Section->setName(sectionName);
      istr >> *expFile.tx7Section;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "SIN")
    {
      expFile.sinSection = new SINSection;
      expFile.sinSection->setName(sectionName);
      istr >> *expFile.sinSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "LOG")
    {
      expFile.logSection = new LOGSection;
      expFile.logSection->setName(sectionName);
      istr >> *expFile.logSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "PRJ")
    {
      expFile.prjSection = new PRJSection;
      expFile.prjSection->setName(sectionName);
      istr >> *expFile.prjSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  if (sectionName == "IFO")
    {
      expFile.ifoSection = new IFOSection;
      expFile.ifoSection->setName(sectionName);
      istr >> *expFile.ifoSection;

      /* Reading next file name or EOS */
      istr.getline(buffer, 4).clear();
      sectionName = buffer;
    }


  return istr;
}



/******************************************************************************
 * ostr << expFile
 ******************************************************************************
 *
 * ***************************************************************************/
ostream & operator<<(ostream & ostr, EXPFile const & expFile)
{
  /* Writing sections */
  if (expFile.expSection) ostr << *expFile.expSection;
  if (expFile.arcSection) ostr << *expFile.arcSection;
  if (expFile.cntSection) ostr << *expFile.cntSection;
  if (expFile.labSection) ostr << *expFile.labSection;
  if (expFile.palSection) ostr << *expFile.palSection;
  if (expFile.tolSection) ostr << *expFile.tolSection;
  if (expFile.tx7Section) ostr << *expFile.tx7Section;
  if (expFile.sinSection) ostr << *expFile.sinSection;
  if (expFile.logSection) ostr << *expFile.logSection;
  if (expFile.prjSection) ostr << *expFile.prjSection;
  if (expFile.ifoSection) ostr << *expFile.ifoSection;

  return ostr << "EOS" << endl;
}
