#ifndef __EXPSECTION_HH_
#define __EXPSECTION_HH_


#include <e00/section.hh>

#include <iostream>
#include <string>


using namespace std;



/******************************************************************************
 *
 *****************************************************************************/
class EXPSection
  : public Section {

public:

  /* Get function */
  string const & getFileName() const;

  /* Set function */
  void setFileName(string const & fileName);
  
  /* Overload of insertion and extraction operators */
  friend istream & operator>>(istream & istr, EXPSection       & expSection);
  friend ostream & operator<<(ostream & ostr, EXPSection const & expSection);


private:

  /* File path */
  string fileName;
};


inline string const & EXPSection::getFileName() const { return fileName; }
inline void           EXPSection::setFileName(string const & fileName)
{
  this->fileName = fileName;
}



#endif // __EXPSECTION_HH_
