#ifndef __LABSECTION_HH_
#define __LABSECTION_HH_


#include <e00/section.hh>
#include <e00/e00point.hh>

#include <iostream>
#include <list>



/* LAB (label) header structured type -  IDs + position */
struct labHeader_t
{
  int labelID;
  int polygonID;

  E00Point position;
};


/* LAB (label) field structured type - header + bounding box */
struct labField_t 
{
  labHeader_t labHeader;

  E00Point upLeftPoint;
  E00Point dnRghtPoint;

  labField_t(labHeader_t const & labHeader) : labHeader(labHeader) {}
};



/******************************************************************************
 *
 *****************************************************************************/
class LABSection
  : public list<labField_t>,
    public Section {

public:

  friend istream & operator>>(istream & istr, LABSection       & labSection);
  friend ostream & operator<<(ostream & ostr, LABSection const & labSection);
};



#endif // __LABSECTION_HH_
