#ifndef __LOGSECTION_HH_
#define __LOGSECTION_HH_


#include <e00/section.hh>

#include <iostream>
#include <string>
#include <list>



/* LOG structured type - date and command line */
struct logField_t
{
  int year;
  int month;
  int day;

  int hour;
  int minute;

  int connectTime;
  int     cpuTime;
  int      ioTime;

  string commandLine;

  string separator;

  friend istream & operator>>(istream & istr, logField_t       & logField);
  friend ostream & operator<<(ostream & ostr, logField_t const & logField);
};



/******************************************************************************
 *
 *****************************************************************************/
class LOGSection
  : public list<logField_t>,
    public Section {

public:

  friend istream & operator>>(istream & istr, LOGSection       & logSection);
  friend ostream & operator<<(ostream & ostr, LOGSection const & logSection);
};



#endif // __LOGSECTION_HH_
