#ifndef __PALSECTION_HH_
#define __PALSECTION_HH_


#include <e00/section.hh>

#include <iostream>
#include <vector>
#include <list>


/* ARC information in polygon type */
struct arcInfo_t
{
  int arcID;
  int fromNodeID;
  int adjacentPolygonID;
};


/* PAL structured type - bounding box + vector of arc infos */
struct palField_t
{
  double xMin, yMin;
  double xMax, yMax;

  vector<arcInfo_t> arcInfos;

  palField_t(int nArcs) : arcInfos(nArcs) {}

  friend istream & operator>>(istream & istr, palField_t       & palField);
  friend ostream & operator<<(ostream & ostr, palField_t const & palField);
};



/******************************************************************************
 * class PALSectionls
 *****************************************************************************/
class PALSection
  : public list<palField_t>,
    public Section {

public:

  friend istream & operator>>(istream & istr, PALSection       & palSection);
  friend ostream & operator<<(ostream & ostr, PALSection const & palSection);
};



#endif // __PALSECTION_HH_
