#ifndef __PRJSECTION_HH_
#define __PRJSECTION_HH_


#include <e00/section.hh>

#include <iostream>
#include <string>
#include <list>



/* PRJ structured type - keyword + value */
struct prjField_t
{
  string keyword;
  string value;

  prjField_t(string keyword) : keyword(keyword) {}

  friend istream & operator>>(istream & istr, prjField_t       & prjField);
  friend ostream & operator<<(ostream & ostr, prjField_t const & prjField);
};



/******************************************************************************
 *
 *****************************************************************************/
class PRJSection
  : public list<prjField_t>,
    public Section {

private:

  string parameters;

public:

  friend istream & operator>>(istream & istr, PRJSection       & prjSection);
  friend ostream & operator<<(ostream & ostr, PRJSection const & prjSection);
};



#endif // __PRJSECTION_HH_
