#include <e00/ticfile.hh>
#include <e00/endl.hh>

#include <iomanip>



/******************************************************************************
 * istr >> ticRecord
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, ticRecord_t & ticRecord)
{
  istr >> ticRecord.IDTic
       >> ticRecord.xTic
       >> ticRecord.yTic;

  /* Ignoring last line end */
  return istr.ignore(2, '\n');
}



/******************************************************************************
 * ostr << ticRecord
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, ticRecord_t const & ticRecord)
{
  return ostr << setw(11) << ticRecord.IDTic
	      << setw((ostr.precision() == 7) ? 14 : 24) << ticRecord.xTic
	      << setw((ostr.precision() == 7) ? 14 : 24) << ticRecord.yTic
	      << endl;
}



/******************************************************************************
 * istr >> ticFile
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, TICFile & ticFile)
{
  istr >> static_cast<IFOFile &>(ticFile);

  ticFile.records.resize(ticFile.ifoHeader.nRecords);
  for (unsigned recordIdx = 0; recordIdx < ticFile.records.size(); ++recordIdx)
    istr >> ticFile.records[recordIdx];

  return istr;
}



/******************************************************************************
 * ostr << ticFile
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, TICFile const & ticFile)
{
  ostr << static_cast<IFOFile const &>(ticFile);

  for (unsigned recordIdx = 0; recordIdx < ticFile.records.size(); ++recordIdx)
    ostr << ticFile.records[recordIdx];

  return ostr;
}
