#include <mlf/mlfpolygon.hh>

#include <iomanip>




/******************************************************************************
 * istr >> polygon
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, MLFPolygon & polygon)
{
  /* Reading number of polyline' indices */
  unsigned nPolylineIdces;
  istr >> nPolylineIdces;

  /* Resizing polygon */
  polygon.resize(nPolylineIdces);

  /* Reading type */
  istr >> polygon.type;

  /* Reading polyline' indices */
  for (unsigned polylineIdxIdx = 0; polylineIdxIdx <
	 nPolylineIdces; ++polylineIdxIdx)
    istr >> polygon[polylineIdxIdx].polylineIdx
	 >> polygon[polylineIdxIdx].reversed;

  return istr;
}



/******************************************************************************
 * ostr << polygon
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, MLFPolygon const & polygon)
{
  /* Writing number of polyline' indices and type */
  ostr << polygon.size() << setw(2)
       << polygon.type << endl;

  /* Reading polyline' indices */
  for (unsigned polylineIdxIdx = 0; polylineIdxIdx <
	 polygon.size(); ++polylineIdxIdx)
    ostr << setw(8) << polygon[polylineIdxIdx].polylineIdx
	 << setw(2) << polygon[polylineIdxIdx].reversed << endl;

  return ostr;
}
