#include <mlf/mlfpolyline.hh>

#include <iomanip>





/******************************************************************************
 * istr >> polyline
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, MLFPolyline & polyline)
{
  unsigned nPoints;
  istr >> nPoints;

  polyline.resize(nPoints);
  for (unsigned vertexIdx = 0; vertexIdx < polyline.size(); ++vertexIdx)
    istr >> polyline[vertexIdx];

  return istr;
}



/******************************************************************************
 * ostr << polyline
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, MLFPolyline const & polyline)
{
  ostr << polyline.size();

  for (unsigned vertexIdx = 0; vertexIdx < polyline.size(); ++vertexIdx)
    {
      if (ostr.precision() == 14 || vertexIdx%2 == 0)
	ostr.put(ostr.widen('\n')).flush();

      ostr << polyline[vertexIdx];
    }

  return ostr.put(ostr.widen('\n')).flush();
}
