#ifndef __MLFRARLAYER_HH_
#define __MLFRARLAYER_HH_


#include <mlf/mlflayer.hh>
#include <mlf/mlfpolyline.hh>
#include <e00/expfile.hh>

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 *
 *****************************************************************************/
class MLFRARLayer
  : public MLFLayer {

public:

  /* Constructors */
  MLFRARLayer(string const & name);
  MLFRARLayer(string const & name, EXPFile const & expFile);

  unsigned numberOfPolylines() const;

  MLFPolyline const & getPolyline(unsigned polylineIdx) const;
  vector<MLFPolyline> const & getPolylines() const;

  MLFPolyline & getPolyline(unsigned polylineIdx);
  vector<MLFPolyline> & getPolylines();

  friend istream & operator>>(istream & istr, MLFRARLayer       & rarLayer);
  friend ostream & operator<<(ostream & ostr, MLFRARLayer const & rarLayer);


private:

  vector<MLFPolyline> polylines;

  void findBoundingBox();
};


inline MLFRARLayer::MLFRARLayer(string const & name) : MLFLayer(name) {}

inline unsigned MLFRARLayer::numberOfPolylines() const
{
  return polylines.size();
}

inline MLFPolyline const & MLFRARLayer::getPolyline(unsigned polylineIdx) const
{
  return polylines[polylineIdx];
}

inline vector<MLFPolyline> const & MLFRARLayer::getPolylines() const
{
  return polylines;
}


inline MLFPolyline & MLFRARLayer::getPolyline(unsigned polylineIdx)
{
  return polylines[polylineIdx];
}

inline vector<MLFPolyline> & MLFRARLayer::getPolylines() { return polylines; }



#endif // __MLFRARLAYER_HH_
