#ifndef __MMFPOLYGON_HH_
#define __MMFPOLYGON_HH_


#include <mlf/mlfpolygon.hh>

#include <iostream>
#include <vector>


using namespace std;



struct MMFPolIndex_t {

  MMFPolIndex_t(int polylineIdx = 0, bool reversed = false)
    : polylineIdx(polylineIdx), reversed(reversed) {}
  MMFPolIndex_t(MLFPolIndex_t const & polIndex)
    : polylineIdx(polIndex.polylineIdx), reversed(polIndex.reversed) {}

  int  polylineIdx;
  bool reversed;
};


/******************************************************************************
 *
 *****************************************************************************/
class MMFPolygon
  : public vector<MMFPolIndex_t> {

public:

  /* Constructors */
  MMFPolygon();
  MMFPolygon(MLFPolygon const & polygon);

  /* Get number of polylines function */
  unsigned numberOfPolylines() const;

  /* Get and set functions */
  int  getType() const;
  void setType(int type);

  /* Redifinion of insertion and extraction operators */
  friend istream & operator>>(istream & istr, MMFPolygon       & polygon);
  friend ostream & operator<<(ostream & ostr, MMFPolygon const & polygon);


private:

  int type;
};


inline MMFPolygon::MMFPolygon() {}
inline MMFPolygon::MMFPolygon(MLFPolygon const & polygon)
  : type(polygon.getType())
{
  insert(end(), polygon.begin(), polygon.end());
}

inline unsigned MMFPolygon::numberOfPolylines() const { return size(); }

inline int  MMFPolygon::getType() const { return type; }
inline void MMFPolygon::setType(int type) { this->type = type; }



#endif // __MMFPOLYGON_HH_
