#include <mmf/mmfresolution.hh>

#include <iomanip>





/******************************************************************************
 * istr >> resolution
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, MMFResolution & resolution)
{
  /* Reading vertices */
  unsigned nVertices;
  istr >> nVertices;

  resolution.vertices.resize(nVertices);
  for (unsigned vertexIdx = 0; vertexIdx <
	 resolution.vertices.size(); ++vertexIdx)
    istr >> resolution.vertices[vertexIdx];


  /* Reading links */
  unsigned nLinks;
  istr >> nLinks;

  resolution.links.resize(nLinks);
  for (unsigned linkIdx = 0; linkIdx < resolution.links.size(); ++linkIdx)
    istr >> resolution.links[linkIdx];


  return istr;
}



/******************************************************************************
 * ostr << resolution
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, MMFResolution const & resolution)
{
  /* Priting vertices */
  ostr << resolution.vertices.size();

  for (unsigned vertexIdx = 0; vertexIdx <
	 resolution.vertices.size(); ++vertexIdx)
    {
      if (ostr.precision() == 14 || vertexIdx%2 == 0)
	ostr << endl;

      ostr << resolution.vertices[vertexIdx];
    }

  ostr << endl;


  /* Priting links */
  ostr << resolution.links.size() << endl;

  for (unsigned linkIdx = 0; linkIdx < resolution.links.size(); ++linkIdx)
    ostr << resolution.links[linkIdx] << endl;


  return ostr;
}
