#include <mtf/mtffile.hh>

#include <string>
#include <iomanip>



/******************************************************************************
 * istr >> mtfFile
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, MTFFile & mtfFile)
{
  /* Reading map name */
  getline(istr, mtfFile.name);

  /* Auxiliary buffers */
  char buffer[4];
  string layerName;

  /* Reading layer name */
  istr.ignore(80, '\n').getline(buffer, 4).clear();
  layerName = buffer;

  if (layerName == "POL")
    {
      mtfFile.polLayer = new MTFPOLLayer(layerName);
      istr >> *mtfFile.polLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "POP")
    {
      mtfFile.popLayer = new MTFPOPLayer(layerName);
      istr >> *mtfFile.popLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "DRG")
    {
      mtfFile.drgLayer = new MTFDRGLayer(layerName);
      istr >> *mtfFile.drgLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "ROD")
    {
      mtfFile.rodLayer = new MTFRODLayer(layerName);
      istr >> *mtfFile.rodLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "RAR")
    {
      mtfFile.rarLayer = new MTFRARLayer(layerName);
      istr >> *mtfFile.rarLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "APT")
    {
      mtfFile.aptLayer = new MTFAPTLayer(layerName);
      istr >> *mtfFile.aptLayer;
    }


  return istr;
}



/******************************************************************************
 * ostr << mtfFile
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, MTFFile const & mtfFile)
{
  /* Wrinting name */
  ostr << mtfFile.name    << endl;

  /* Writing layers */
  if (mtfFile.polLayer) ostr << endl << *mtfFile.polLayer;
  if (mtfFile.popLayer) ostr << endl << *mtfFile.popLayer;
  if (mtfFile.drgLayer) ostr << endl << *mtfFile.drgLayer;
  if (mtfFile.rodLayer) ostr << endl << *mtfFile.rodLayer;
  if (mtfFile.rarLayer) ostr << endl << *mtfFile.rarLayer;
  if (mtfFile.aptLayer) ostr << endl << *mtfFile.aptLayer;

  return ostr;
}
