#include <mtf/mtfpoint.hh>

#include <iomanip>



/******************************************************************************
 * istr >> point
 ******************************************************************************
 * Reads the cartesian coordinates of 'point' from 'istr'.
 *****************************************************************************/
istream & operator>>(istream & istr, MTFPoint & point)
{
  return istr >> point.x
	      >> point.y
	      >> point.tolerance
	      >> point.leftSonIdx
	      >> point.rghtSonIdx;
}



/******************************************************************************
 * ostr << point
 ******************************************************************************
 * Writes the cartesian coordinates of 'point' in 'ostr'.
 *****************************************************************************/
ostream & operator<<(ostream & ostr, MTFPoint const & point)
{
 return ostr << setw(ostr.precision()+7) << point.x
	     << setw(ostr.precision()+7) << point.y
	     << setw(ostr.precision()+7) << point.tolerance
	     << setw(4)                  << point.leftSonIdx
	     << setw(4)                  << point.rghtSonIdx;
}



/******************************************************************************
 * point.readXY(ostr).
 ******************************************************************************
 * Reads only the cartesian coordinates of 'point' from 'istr'.
 *****************************************************************************/
void MTFPoint::readXY(istream & istr)
{
  istr >> x >> y;
}



/******************************************************************************
 * point.writeXY(ostr);
 ******************************************************************************
 * Writes only the cartesian coordinates of 'point' in 'ostr'.
 *****************************************************************************/
void MTFPoint::writeXY(ostream & ostr) const
{
  ostr << setw(ostr.precision()+7) << x
       << setw(ostr.precision()+7) << y;
}
