#include <mvf/mvffile.hh>

#include <string>
#include <iomanip>



/******************************************************************************
 * istr >> mvfFile
 ******************************************************************************
 *
 *****************************************************************************/
istream & operator>>(istream & istr, MVFFile & mvfFile)
{
  /* Reading map name */
  getline(istr, mvfFile.name);

  /* Auxiliary buffers */
  char buffer[4];
  string layerName;

  /* Reading layer name */
  istr.ignore(80, '\n').getline(buffer, 4).clear();
  layerName = buffer;

  if (layerName == "POL")
    {
      mvfFile.polLayer = new MVFPOLLayer(layerName);
      istr >> *mvfFile.polLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "POP")
    {
      mvfFile.popLayer = new MVFPOPLayer(layerName);
      istr >> *mvfFile.popLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "DRG")
    {
      mvfFile.drgLayer = new MVFDRGLayer(layerName);
      istr >> *mvfFile.drgLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "ROD")
    {
      mvfFile.rodLayer = new MVFRODLayer(layerName);
      istr >> *mvfFile.rodLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "RAR")
    {
      mvfFile.rarLayer = new MVFRARLayer(layerName);
      istr >> *mvfFile.rarLayer;

      /* Reading next layer name */
      istr.ignore(80, '\n').getline(buffer, 4).clear();
      layerName = buffer;
    }


  if (layerName == "APT")
    {
      mvfFile.aptLayer = new MVFAPTLayer(layerName);
      istr >> *mvfFile.aptLayer;
    }


  return istr;
}



/******************************************************************************
 * ostr << mvfFile
 ******************************************************************************
 *
 *****************************************************************************/
ostream & operator<<(ostream & ostr, MVFFile const & mvfFile)
{
  /* Wrinting name */
  ostr << mvfFile.name    << endl;

  /* Writing layers */
  if (mvfFile.polLayer) ostr << endl << *mvfFile.polLayer;
  if (mvfFile.popLayer) ostr << endl << *mvfFile.popLayer;
  if (mvfFile.drgLayer) ostr << endl << *mvfFile.drgLayer;
  if (mvfFile.rodLayer) ostr << endl << *mvfFile.rodLayer;
  if (mvfFile.rarLayer) ostr << endl << *mvfFile.rarLayer;
  if (mvfFile.aptLayer) ostr << endl << *mvfFile.aptLayer;

  return ostr;
}
