#include <mvf/mvfpoint.hh>

#include <iomanip>



/******************************************************************************
 * istr >> point
 ******************************************************************************
 * Reads the cartesian coordinates of 'point' from 'istr'.
 *****************************************************************************/
istream & operator>>(istream & istr, MVFPoint & point)
{
  return istr >> point.x >> point.y >> point.tolerance;
}



/******************************************************************************
 * ostr << point
 ******************************************************************************
 * Writes the cartesian coordinates of 'point' in 'ostr'.
 *****************************************************************************/
ostream & operator<<(ostream & ostr, MVFPoint const & point)
{
 return ostr << setw(ostr.precision()+7) << point.x
	     << setw(ostr.precision()+7) << point.y
	     << setw(ostr.precision()+7) << point.tolerance;
}



/******************************************************************************
 * point.readXY(ostr).
 ******************************************************************************
 * Reads only the cartesian coordinates of 'point' from 'istr'.
 *****************************************************************************/
void MVFPoint::readXY(istream & istr)
{
  istr >> x >> y;
}



/******************************************************************************
 * point.writeXY(ostr);
 ******************************************************************************
 * Writes only the cartesian coordinates of 'point' in 'ostr'.
 *****************************************************************************/
void MVFPoint::writeXY(ostream & ostr) const
{
  ostr << setw(ostr.precision()+7) << x
       << setw(ostr.precision()+7) << y;
}
