#include <iostream>
#include <fstream>
#include <cstdlib>

#include "map.hh"




int main(int argc, char * argv[])
{
  // Arguments
  string  inFileName; //  Input file name
  string outFileName; // Output file name

  if (argc >= 2)  inFileName = argv[1];
  if (argc >= 3) outFileName = argv[2];


  // Setting default streams to standard input and output
  istream *  inStream = &cin;
  ostream * outStream = &cout;


  // File streams
  ifstream  inFileStream;
  ofstream outFileStream;


  // Testing for openning input file
  if (!inFileName.empty())
    {
      inFileStream.open(inFileName.c_str());
      if (!inFileStream.is_open())
	{
	  cerr << argv[0] << ": could not open in file "
	       << inFileName << endl;
	  exit(-1);
	}

      inStream = static_cast<istream *>(&inFileStream);
    }

  // Testing for openning output file
  if (!outFileName.empty())
    {
      outFileStream.open(outFileName.c_str());
      if (!outFileStream.is_open())
	{
	  cerr << argv[0] << ": could not open out file "
	       << outFileName << endl;
	  exit(-1);
	}

      outStream = static_cast<ostream *>(&outFileStream);
    }


  // Reading map
  Map map;
  *inStream >> map;


  // Applying Topological Consistency Edition
  map.removeRedundancies();


  // Writing simplified map
  *outStream << map;


  return 0;
}
