#include <bvfmap/bvfpoint.hh>

#include <iomanip>




/******************************************************************************
 * point.printFig(ostr)
 ******************************************************************************
 * Prints 'point' on 'ostr' at Xfig format.
 *****************************************************************************/
void BVFPoint::printFig(ostream & ostr) const
{
  ostr << x << y;
}



/******************************************************************************
 * istr >> point
 ******************************************************************************
 * Reads the cartesian coordinates of 'point' from 'istr'.
 *****************************************************************************/
istream & operator>>(istream & istr, BVFPoint & p)
{
  istr.read(reinterpret_cast<char *>(&p.x),             sizeof(double));
  istr.read(reinterpret_cast<char *>(&p.y),             sizeof(double));
  istr.read(reinterpret_cast<char *>(&p.distance),      sizeof(double));
  istr.read(reinterpret_cast<char *>(&p.initTolerance), sizeof(double));
  istr.read(reinterpret_cast<char *>(&p.currTolerance), sizeof(double));
  istr.read(reinterpret_cast<char *>(&p.leftSonIdx),    sizeof(int));
  istr.read(reinterpret_cast<char *>(&p.rghtSonIdx),    sizeof(int));
  istr.read(reinterpret_cast<char *>(&p.level),         sizeof(unsigned));
  istr.read(reinterpret_cast<char *>(&p.essential),     sizeof(bool));

  return istr;
}



/******************************************************************************
 * ostr << point
 ******************************************************************************
 * Writes the cartesian coordinates of 'point' into 'ostr'.
 *****************************************************************************/
ostream & operator<<(ostream & ostr, BVFPoint const & p)
{
  ostr.write(reinterpret_cast<char const*>(&p.x),            sizeof(double));
  ostr.write(reinterpret_cast<char const*>(&p.y),            sizeof(double));
  ostr.write(reinterpret_cast<char const*>(&p.distance),     sizeof(double));
  ostr.write(reinterpret_cast<char const*>(&p.initTolerance),sizeof(double));
  ostr.write(reinterpret_cast<char const*>(&p.currTolerance),sizeof(double));
  ostr.write(reinterpret_cast<char const*>(&p.leftSonIdx),   sizeof(int));
  ostr.write(reinterpret_cast<char const*>(&p.rghtSonIdx),   sizeof(int));
  ostr.write(reinterpret_cast<char const*>(&p.level),        sizeof(unsigned));
  ostr.write(reinterpret_cast<char const*>(&p.essential),    sizeof(bool));

  return ostr;
}



/******************************************************************************
 * point.readXY(istr)
 ******************************************************************************
 * Reads the cartesian coordinates of 'point' from 'istr'.
 *****************************************************************************/
void BVFPoint::readXY(istream & istr)
{
  istr.read(reinterpret_cast<char *>(&x), sizeof(double));
  istr.read(reinterpret_cast<char *>(&y), sizeof(double));
}



/******************************************************************************
 * point.writeXY(ostr)
 ******************************************************************************
 * Reads the cartesian coordinates of 'point' from 'istr'.
 *****************************************************************************/
void BVFPoint::writeXY(ostream & ostr) const
{
  ostr.write(reinterpret_cast<char const *>(&x), sizeof(double));
  ostr.write(reinterpret_cast<char const *>(&y), sizeof(double));
}
