#ifndef __BVFPOLYLINE_HH_
#define __BVFPOLYLINE_HH_


#include <bvfmap/bvfpoint.hh>

#include <iostream>
#include <vector>


using namespace std;



/******************************************************************************
 * 'BVFPolyline' is the polyline class. It is a vector of Points.
 *****************************************************************************/
class BVFPolyline
  : public vector<BVFPoint> {

public:

  /* Polyline's number of vertices function */
  unsigned numberOfVertices() const;


  /* Bounding box variables' get functions */
  double getXMin() const;
  double getXMax() const;
  double getYMin() const;
  double getYMax() const;


  /* Printing function */
  void printFig(ostream & ostr) const;

  /* Friendship relation of insertion and extraction operators */
  friend istream & operator>>(istream & istr, BVFPolyline       & polyline);
  friend ostream & operator<<(ostream & ostr, BVFPolyline const & polyline);


private:

  double xMin, xMax;
  double yMin, yMax;
};



inline unsigned BVFPolyline::numberOfVertices() const { return size(); }


inline double BVFPolyline::getXMin() const { return xMin; }
inline double BVFPolyline::getXMax() const { return xMax; }
inline double BVFPolyline::getYMin() const { return yMin; }
inline double BVFPolyline::getYMax() const { return yMax; }



#endif // __BVFPOLYLINE_HH_
