#include <infmap/infpoint.hh>

#include <iomanip>




/******************************************************************************
 * point.printFig(ostr)
 ******************************************************************************
 * Prints 'point' on 'ostr' at Xfig format.
 *****************************************************************************/
void INFPoint::printFig(ostream & ostr) const
{
  ostr << x << y;
}



/******************************************************************************
 * istr >> point
 ******************************************************************************
 * Reads the cartesian coordinates of 'point' from 'istr'.
 *****************************************************************************/
istream & operator>>(istream & istr, INFPoint & point)
{
  return istr >> point.x >> point.y;
}


/******************************************************************************
 * ostr << point
 ******************************************************************************
 * Writes the cartesian coordinates of 'point' into 'ostr'.
 *****************************************************************************/
ostream & operator<<(ostream & ostr, INFPoint const & point)
{
  return ostr << setw(ostr.precision()+7) << point.x
	      << setw(ostr.precision()+7) << point.y;
}
