#include <lvfmap/lvfpoint.hh>

#include <iomanip>




/******************************************************************************
 * point.printFig(ostr)
 ******************************************************************************
 * Prints 'point' on 'ostr' at Xfig format.
 *****************************************************************************/
void LVFPoint::printFig(ostream & ostr) const
{
  ostr << x << y << distance << tolerance << level;
}



/******************************************************************************
 * istr >> point
 ******************************************************************************
 * Reads the cartesian coordinates of 'point' from 'istr'.
 *****************************************************************************/
istream & operator>>(istream & istr, LVFPoint & point)
{
  return istr >> point.x
	      >> point.y
	      >> point.distance
	      >> point.tolerance
	      >> point.level;
}


/******************************************************************************
 * ostr << point
 ******************************************************************************
 * Writes the cartesian coordinates of 'point' into 'ostr'.
 *****************************************************************************/
ostream & operator<<(ostream & ostr, LVFPoint const & point)
{
  return ostr << setw(ostr.precision()+7) << point.x
	      << setw(ostr.precision()+7) << point.y
	      << setw(ostr.precision()+7) << point.distance
	      << setw(ostr.precision()+7) << point.tolerance
	      << setw(4)                  << point.level;
}
