/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/



/******************************************************************************
 * exportAsFig.getFileName(fileName, mode)
 ******************************************************************************
 *
 *****************************************************************************/
QString ExportAsFig::getFileName() const
{
  if (folderNameLine->text().endsWith("/") ||
      folderNameLine->text() == "")
    return folderNameLine->text()+fileNameLine->text();
  
  return folderNameLine->text()+'/'+fileNameLine->text();
}
                                                                               
                                                                               

/******************************************************************************
 * exportAsFig.getColorMode()
 ******************************************************************************
 *
 *****************************************************************************/
int ExportAsFig::getColorMode() const
{
  if (fullColorMode->isChecked()) return FULL_COLOR_MODE;
  if (grayScaleMode->isChecked()) return GRAY_SCALE_MODE;
  
  return FULL_COLOR_MODE;
}



/******************************************************************************
 * exportAsFig.getNoFill()
 ******************************************************************************
 *
 *****************************************************************************/
bool ExportAsFig::getNoFill() const
{
  return noFillMode->isChecked();
}



/******************************************************************************
 * exportAsFig.getExportFileName(fileName, colorMode, noFill)
 ******************************************************************************
 *
 *****************************************************************************/
void ExportAsFig::getExportFileName(QString const & fileName, int colorMode,
                                    bool noFill)
{
  fileNameLine  ->setText(fileName.section('/', -1));
  folderNameLine->setText(fileName.section('/', 0, -2)+'/');
  
  fullColorMode->setChecked((colorMode == FULL_COLOR_MODE) ? TRUE : FALSE);
  grayScaleMode->setChecked((colorMode == GRAY_SCALE_MODE) ? TRUE : FALSE);
  
  noFillMode->setChecked(noFill);
  
  
  exec();
}



/******************************************************************************
 * exportAsFig.browseButtonClicked()
 ******************************************************************************
 *
 *****************************************************************************/
void ExportAsFig::browseButtonClicked()
{
  QString folder = '/'+folderNameLine->text().
                   section('/', 0, -2, QString::SectionSkipEmpty);
  
  folderNameLine->setText(QFileDialog::getExistingDirectory(folder, this));
}
